/*
 * Knight.cpp
 *
 *  Created on: 19/apr/2012
 *      Author: utente
 */

#include "Knight.h"
#include "MeleeWeapon.h"
#include "MissileWeapon.h"

#include <iostream>
using namespace std;

Knight::~Knight() {
	// TODO Auto-generated destructor stub
}

Knight::Knight(int hp, int d, int ab) : Character(hp, d), ability(ab) {
}


Knight::Knight(const Knight& orig) {
	copier(orig); // avoid code duplication (DRY: don't repeat yourself) - duplicated code could be refactored using "Extract method" technique
}

Knight& Knight::operator =(const Knight& right) {
	if( this != &right ) {
		delete weapon;
		copier(right);
	}
	return *this;
}

void Knight::copier(const Knight& k) {
	// problem: adding weapon subclasses requires to constantly change the following (commented code)...
//	if( dynamic_cast<MeleeWeapon*>(k.weapon) )
//		weapon = new MeleeWeapon( static_cast<const MeleeWeapon&>(*k.weapon) ); // default copy constructor requires const reference as argument type
//	else if( dynamic_cast<MissileWeapon*>(k.weapon) )
//		weapon = new MissileWeapon( static_cast<const MissileWeapon&>(*k.weapon) );
	// solution: use the virtual copy constructor idiom
	weapon = k.weapon->clone();

	ability = k.ability;
	HP = k.HP;
	armor = k.armor;
}

bool Knight::fight(Character& enemy) {
	int hit = getWeapon()->useWeapon();

	int damage = 0;
	if( hit > enemy.getArmor() ) {
		damage = enemy.receiveDamage(hit);
	}
	hit = getWeapon()->useWeapon() - 2;
	if( hit < 0 )
		hit = 0;
	if( hit > enemy.getArmor() ) {
		damage += enemy.receiveDamage(hit);
	}
	bool result = false;
	if( damage ) {
		cout << "Nemico colpito: " << damage << " - ha ancora HP: " << enemy.getHP() << endl;
		result = true;
	}
	return result;
}

int Knight::receiveDamage(int points) {
	int avoidChance = rand() % 10;
	if( avoidChance < ability )
		return 0;
	if( getArmor() > 6 )
		points /= 4;
	else if( getArmor() > 4 )
		points /= 3;
	else
		points /= 2;

	setHP( getHP() - points );

	return points;
}
